package stat;

public class Bernoulli extends Stat2
{
    public Bernoulli( )           { reset( ); }

    public void   add( boolean s )
    {
        if ( s )  N1++;
        else      N0++;
    }
    public void   add_success( boolean s ) { N1++;              }
    public void   add_failure( boolean s ) { N0++;              }
    public void   reset( )                 { N=-1; N0 = N1 = 0; }
    public int    size( )                  { return N0+N1;      }
    public void   update( )
    {
        if ( N != N0+N1 )
        {
            N  = N0+N1;
            k  = N < 1 ? 1 : 1.0/N;
            k1 = N < 2 ? 1 : 1.0/(N-1);
            S  = 1.0*N1;
            S2 = 1.0*N1;
        }
    }
    
    //public double mean( )      { return 1.0*N1/(N0+N1);     }
    //public double var( )       { return 1.0*N0*N1/(N0+N1);  }
    //public double deviation( ) { return Math.sqrt( var() ); }

    // Internal data
    int      N;   // N=N0+N1 when sums were last updated
    int      N0;
    int      N1;
}
