package stat;

import java.lang.Math;
//import java.util.Arrays;

public abstract class Stat2 implements Stat
{
    public abstract void   reset();
    
    public abstract int    size( );
    public double mean( )        { update(); return k*S;                      }
    public double var( )         { update(); return k*S2 - k*k*S*S;           }
    public double deviation( )   {           return Math.sqrt( var() );       }

    //  Estimates
    public double E_mean( )      {           return mean();                   }
    public double E_var( )       { update(); return k1*( S2 - k*S*S );        }
    public double E_deviation( ) { update(); return Math.sqrt( E_var() );     }
    public double E_mean_var( )  { update(); return k*E_var();                }
    public double E_mean_deviation( ) {      return Math.sqrt(E_mean_var());  }

    //  new supporting methods and variables
    public abstract void   update();  // updates k, k1, S and S2

    public double k;         // 1/min(1,n)
    public double k1;        // 1/min(1,(n-1))
    public double S;         // s1   + s2   + ...
    public double S2;        // s1^2 + s2^2 + ...
}
