/***********************************************
 *
 *  doubleStat.java
 *
 *  Esa Hyyti, 2004-2005
 *
 ***********************************************/

package stat;

import java.lang.Math;

/***********************************************/

class StatData
{
    StatData( double e, StatData n )
    {
        value = e;
        next  = n;
    }
    public StatData  next;
    public double    value;
}

/***********************************************/

public class doubleStat extends Stat2
{
    public doubleStat( ) 
    {
        sums_valid = false;
        DL = null;
        nl = 0;
        Da = null;
        na = 0;
    }

    public int  size( )
    {
        return nl;
    }
    
    public void add( double sample )
    {
        sums_valid = false;
        DL = new StatData( sample, DL );
        nl++;
    }
    
    public void reset( )
    {
        sums_valid = false;
        DL = null;
        nl = 0;
        
        if ( na > 1024 )
        {
            Da = null;
            na = 0;
        }
    }

    /**************************************************
     *
     *  some internal variables
     *
     **************************************************/

    private StatData      DL;          // samples itself, simple list
    private int           nl;          // no. of elements in list, i.e. samples
    private double[]      Da;          // the same in array
    private int           na;          // no. of elements reserved in array
    private boolean       sums_valid;  // are D, S and S2 etc valid?

    private void update_Da( )
    {
        if ( na < nl )
        {
            na = nl + 100;
            Da = new double[ na ];
        }
        
        int i=0;
        for( StatData s=DL; s!=null; s=s.next )
            Da[i++] = s.value;
    }
    
    public void update( )
    {
        if ( sums_valid )
            return;

        update_Da( );
            
        k  = nl < 1 ? 0.0 : 1.0/nl;
        k1 = nl < 2 ? 0.0 : 1.0/(nl-1);
        S  = S2 = 0;
        for( int i=0; i<nl; i++ )
        {
            double e = Da[i];
            S  += e;
            S2 += e*e;
        }
        sums_valid = true;
    }
}
